﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;


namespace CAN_2053C_demo
{
    public partial class Form1 : Form
    {
        Byte VxCAN_port;
        Graphics g;
        Bitmap img = new Bitmap(544, 190);
        uint DI_data1 = 0, DI_data2 = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void Btn_GetDLLVersion_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            Char[] ch = new Char[600];
                        
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_DLL_Ver(ch);
            if (ret == 0)
            {
                String _str = new String(ch);
                MessageBox.Show(_str);
            } 
        }

        private void Btn_SearchModule_Click(object sender, EventArgs e)
        {
            UInt32 ret;
            byte Percentage = 0;
            pBar_SearchModule.Value = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_SearchCANModule();
            if (ret == 0)
            {
                while (pBar_SearchModule.Value < pBar_SearchModule.Maximum)
                {

                    ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_IsSearchCANModuleOK(ref Percentage);
                    pBar_SearchModule.Value = Convert.ToInt32(Percentage);                  
                }

                MessageBox.Show("Search Done!");
            }
        }

        private void Btn_GetModuleList_Click(object sender, EventArgs e)
        {
            Byte _TotalVxCANPort=0;
            Byte[] _VxCAN_LocalPortIDList = new Byte[50];
            UInt32 ret = 0;
            UInt32[] _VxCAN_NameIDList = new UInt32[50];
            UInt32[] _VxCAN_IDList = new UInt32[50];
            UInt32[] _VxCAN_COMPortBaudRate = new UInt32[50];
            String[] _VxCAN_NameStr = new String[50];
            String[] _VxCAN_VerStr = new String[50];

            dataGridView1.Columns.Clear();
            dataGridView1.Rows.Clear();
            dataGridView1.Columns.Add("VxCANPort", "VxCANPort");
            dataGridView1.Columns.Add("VxCAN_NameIDList", "VxCAN_NameIDList");
            dataGridView1.Columns.Add("VxCAN_IDList", "VxCAN_IDList");
            dataGridView1.Columns.Add("VxCAN_COMPortBaudRate", "VxCAN_COMPortBaudRate");
            dataGridView1.Columns.Add("VxCAN_NameStr", "VxCAN_NameStr");
            dataGridView1.Columns.Add("VxCAN_VerStr", "VxCAN_VerStr");
            dataGridView1.Columns.Add("VxCAN_LocalPortIDList", "VxCAN_LocalPortIDList");

 

            for (int i = 0; i < 50; i++)
            {
                //Set Default Value
                _VxCAN_NameStr[i] = new String('\0',50);
                _VxCAN_VerStr[i] = new String('\0', 50);
            }



            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_TotalCANPort(ref _TotalVxCANPort, _VxCAN_NameIDList, _VxCAN_IDList, _VxCAN_COMPortBaudRate, _VxCAN_NameStr, _VxCAN_VerStr, _VxCAN_LocalPortIDList);
            if (ret == 0)
            {
                for (int i = 0; i < _TotalVxCANPort; i++)
                {
                    dataGridView1.Rows.Add();
                    dataGridView1["VxCANPort", dataGridView1.Rows.Count - 1].Value = i;
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_NameIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameIDList[i];
                    dataGridView1["VxCAN_IDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_IDList[i];
                    dataGridView1["VxCAN_COMPortBaudRate", dataGridView1.Rows.Count - 1].Value = _VxCAN_COMPortBaudRate[i];
                    dataGridView1["VxCAN_NameStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_NameStr[i];
                    dataGridView1["VxCAN_VerStr", dataGridView1.Rows.Count - 1].Value = _VxCAN_VerStr[i];
                    dataGridView1["VxCAN_LocalPortIDList", dataGridView1.Rows.Count - 1].Value = _VxCAN_LocalPortIDList[i];
                }            
            }
        }
         

        private void Btn_OpenCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_OpenCAN((Byte)dataGridView1.CurrentRow.Index, (UInt32)VxCAN_DotNET.VxCAN_DotNET.CAN_BaudRate.BR_1000K);
            if (ret == 0)
            {
                MessageBox.Show("Open CAN Port 0 done!!");
            }
            VxCAN_port = (Byte)dataGridView1.CurrentRow.Index;
            g = Graphics.FromImage(img);
            
        }

        private void Btn_CloseCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearRxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ClearTxBuffer(VxCAN_port);
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CloseCAN(VxCAN_port);

        }

        private void Btn_SendCANMsg_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            byte[] Data = new Byte[8];
            ushort RxCnt = 0;
            UInt32 ret = 0, ID = 0;
            Double MsgTimeStamps = 0;
            UInt32 TimeOut = 0;
            int[] bit = new int[8];
            UInt16 index = 0, subindex = 0;

            //using remote request to get DI channels status 
            ID = 0x180 + NumID;
            RTR = 0x01;
            Len = 0x01;
            Data[0] = 0x00;
            Data[1] = 0x00;
            Data[2] = 0x00;
            Data[3] = 0x00;
            Data[4] = 0x00;
            Data[5] = 0x00;
            Data[6] = 0x00;
            Data[7] = 0x00;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);

            Thread.Sleep(20);

            

            while (true && TimeOut++ < 20000)
            {
                //get the amount of CAN message in Virtual CAN buffer
                ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_RxMsgCount(VxCANPort, ref RxCnt);
                if (ret == 0)
                {
                    if (RxCnt > 0)
                    {
                        //output all CAN message in Virtual CAN buffer
                        for (int i = 0; i < RxCnt; i++)
                        {
                            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_Receive(VxCANPort, ref ID, ref Mode, ref RTR, ref Len, Data, ref MsgTimeStamps);
                            if (ret == 0)
                            {
                                if (i == (RxCnt - 1))
                                {
                                    if (ID == (0x180 + NumID))
                                    {

                                        DI_data1 = Data[0];
                                        DI_data2 = Data[1];
                                        DI_status();
                                    }
                                }
                            }
                        }
                        break;
                    }
                }
            }            

          
        }

        private void Btn_ResetCAN_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_ResetCAN(VxCAN_port);
            if(ret == 0)
                MessageBox.Show("Reset CAN Port 0 done!");
        }

        private void Btn_CANStatus_Click(object sender, EventArgs e)
        {
            UInt32 ret = 0;
            UInt32 ModuleStatus = 0;
            UInt32 CANChipStatus = 0;

            ret = VxCAN_DotNET.VxCAN_DotNET.VxCAN_CANStatus(VxCAN_port, ref ModuleStatus, ref CANChipStatus);
            if(ret == 0)
            {
                MessageBox.Show("Module Status = "+ModuleStatus.ToString());
                MessageBox.Show("CAN Chip Status = " + CANChipStatus.ToString());
            }
        }

        private void DI_status()
        {
            //DI_data1:DO 0~7
            if ((DI_data1 & 0x01) == 0x01)
            {
                drawLED(23, 35, true);
            }
            else
            {
                drawLED(23, 35, false);
            }
            if ((DI_data1 & 0x02) == 0x02)
            {
                drawLED(23 + 66, 35, true);
            }
            else
            {
                drawLED(23 + 66, 35, false);
            }

            if ((DI_data1 & 0x04) == 0x04)
            {
                drawLED(23 + 66 * 2, 35, true);
            }
            else
            {
                drawLED(23 + 66 * 2, 35, false);
            }

            if ((DI_data1 & 0x08) == 0x08)
            {
                drawLED(23 + 66 * 3, 35, true);
            }
            else
            {
                drawLED(23 + 66 * 3, 35, false);
            }

            if ((DI_data1 & 0x10) == 0x10)
            {
                drawLED(23 + 66 * 4, 35, true);
            }
            else
            {
                drawLED(23 + 66 * 4, 35, false);
            }

            if ((DI_data1 & 0x20) == 0x20)
            {
                drawLED(23 + 66 * 5, 35, true);
            }
            else
            {
                drawLED(23 + 66 * 5, 35, false);
            }

            if ((DI_data1 & 0x40) == 0x40)
            {
                drawLED(23 + 66 * 6, 35, true);
            }
            else
            {
                drawLED(23 + 66 * 6, 35, false);
            }

            if ((DI_data1 & 0x80) == 0x80)
            {
                drawLED(23 + 66 * 7, 35, true);
            }
            else
            {
                drawLED(23 + 66 * 7, 35, false);
            }

            //DI_data2:DO 8~15
            if ((DI_data2 & 0x01) == 0x01)
            {
                drawLED(23, 121, true);
            }
            else
            {
                drawLED(23, 121, false);
            }
            if ((DI_data2 & 0x02) == 0x02)
            {
                drawLED(23 + 66, 121, true);
            }
            else
            {
                drawLED(23 + 66, 121, false);
            }

            if ((DI_data2 & 0x04) == 0x04)
            {
                drawLED(23 + 66 * 2, 121, true);
            }
            else
            {
                drawLED(23 + 66 * 2, 121, false);
            }

            if ((DI_data2 & 0x08) == 0x08)
            {
                drawLED(23 + 66 * 3, 121, true);
            }
            else
            {
                drawLED(23 + 66 * 3, 121, false);
            }

            if ((DI_data2 & 0x10) == 0x10)
            {
                drawLED(23 + 66 * 4, 121, true);
            }
            else
            {
                drawLED(23 + 66 * 4, 121, false);
            }

            if ((DI_data2 & 0x20) == 0x20)
            {
                drawLED(23 + 66 * 5, 121, true);
            }
            else
            {
                drawLED(23 + 66 * 5, 121, false);
            }

            if ((DI_data2 & 0x40) == 0x40)
            {
                drawLED(23 + 66 * 6, 121, true);
            }
            else
            {
                drawLED(23 + 66 * 6, 121, false);
            }

            if ((DI_data2 & 0x80) == 0x80)
            {
                drawLED(23 + 66 * 7, 121, true);
            }
            else
            {
                drawLED(23 + 66 * 7, 121, false);
            }

        }
        private void drawLED(int x, int y, bool status)
        {
            System.Drawing.SolidBrush drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.White);
            if (status)
                drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.GreenYellow);
            else
                drawBrush = new System.Drawing.SolidBrush(System.Drawing.Color.Gray);

            g.FillEllipse(drawBrush, x, y, 30, 30);
            pictureBox1.Refresh();

        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            pictureBox1.Image = img;
        }

        private void operation_mode_Click(object sender, EventArgs e)
        {
            UInt32 NumID = 0x000;
            NumID = (UInt32)(comboBox1.SelectedIndex + 1);
            Byte DataID = 0x0;
            DataID = (Byte)(comboBox1.SelectedIndex + 1);
            Byte VxCANPort = VxCAN_port, Mode = 0x0, RTR = 0x0, Len = 0x0;
            UInt32 ID = 0x000;
            Byte[] Data = new Byte[8];

            ID = 0x000;
            Len = 0x2;
            Data[0] = 0x01;
            Data[1] = DataID;
            VxCAN_DotNET.VxCAN_DotNET.VxCAN_Send(VxCANPort, ID, Mode, RTR, Len, Data);
            MessageBox.Show("CAN2055C is in operation mode!");
        }


    }
}
